<?php

class baur_Plugin {
    function __construct() {
        // add filter hooks, wp_enqueue_script, etc.

        // To assign a method from your class to a WP 
        // function do something like this
		add_action('admin_menu', array($this,'baur_admin_menu'));
        add_action('admin_init',  array($this, 'baur_init'));
    }
	
	//init
	public function baur_init(){
		register_setting( 'baur_Options', 'baur' );
		$this->ba_ur_get_option('baur');
	}
	
	//admin menu
	public function baur_admin_menu() {
		add_options_page('Bainternet User Ranks', 'Bainternet User Ranks', 'manage_options', 'ba_user_rank', array($this,'ba_user_rank_options'));
	}
	
	//get user points
	public function ba_get_user_points($user_id ,$title = false){
		if (!isset($user_id)){return false;}
		$options = $this->ba_ur_get_option();
		switch($options['count']){
			case '1':
			//only posts
				$user_count_points = $this->get_user_posts_count($user_id) * $options['post'];
			break;
			case '2':
			//only comments
				$user_count_points = $this->get_user_comment_count($user_id) * $options['comment'];
			break;
			case '3':
			//Both posts and comments
			$user_count_points = ($this->get_user_posts_count($user_id) * $options['post']) + ($this->get_user_comment_count($user_id) * $options['comment']);
			break;
		}
		if ($title){
			$te = __('Not Ranked Yet');
			foreach($options['levels'] as $key ){
				if ($user_count_points > $key['count']){
					$te = $key['title'];
				}else{break;}
			}
			$re = array('points' => $user_count_points, 'title' => $te);
			return $re;
		}
		return $user_count_points;
	}
	
	//options
	public function ba_ur_get_option(){
		$temp = array(
		'levels' => array(
			array('title' => 'noobie' ,'count'=> 100),
			array('title' => 'advanced' ,'count'=> 1000),
			array('title' => 'expert' ,'count'=> 3000)),
		'count' => 1,
		'post' => 10,
		'comment' => 2);
		
		$options = get_option('baur');
		 if (!empty($options)){
		 
			if (!empty($options['levels'])){
				 unset($temp['levels']);
				 $temp['levels'] = $options['levels'];
			}
			if (!empty($options['count'])){
				$temp['count'] = $options['count'];
			}
			if (!empty($options['post'])){
				$temp['post'] = $options['post'];
			}
			if (!empty($options['comment'])){
				$temp['comment'] = $options['comment'];
			}
			
		}
		
		update_option('baur', $temp);
		//delete_option('baur');
		return $temp;
		
		
	}
	
	//user post count
	public function get_user_posts_count($user_ID){
		$args = array('author' => $user_ID, 'posts_per_page' => -1);
		$the_query = new WP_Query( $args );
		if ($the_query->post_count > 0){
			return $the_query->post_count;
		}
		else{
			return 0;
		}
	}

	//user comment count
	public function get_user_comment_count($user_ID){
		global $wpdb;
		$where = 'WHERE comment_approved = 1 AND user_id = '.$user_ID;
		$comment_counts = $wpdb->get_results("SELECT user_id, COUNT( * ) AS total
				FROM {$wpdb->comments}
				{$where}
				GROUP BY user_id
			", object);
		if ($comment_counts > 0 ){
			return $count->total;
		}else{
			return 0;
		}
	}

	//options page
	public function ba_user_rank_options(){
		
		 if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	  }

		?>
		<div class="wrap">
			<div id="icon-options-general" class="icon32">
				
			</div><h2><?php echo __('Bainternet User Ranks'); ?></h2>
			<h3><?php echo __('General settings'); ?></h3>
			<form method="post" action="options.php">
			<?php settings_fields('baur_Options');
				$options = $this->ba_ur_get_option('baur');
			?>
			<?php //print_r($options); ?>

			<table class="form-table">

			<tr valign="top">
			<th scope="row"><?php echo __('Rank Based on:'); ?></th>
			<td>
				<input type="radio" name="baur[count]" value="1" <?php if ($options[count] == 1 ) echo ' checked'; ?> /><?php echo __('Posts count.'); ?> <br />
				<input type="radio" name="baur[count]" value="2" <?php if ($options[count] == 2 ) echo ' checked'; ?> /><?php echo __('Comments count.'); ?> <br />
				<input type="radio" name="baur[count]" value="3" <?php if ($options[count] == 3 ) echo ' checked'; ?> /><?php echo __('Both Posts and Comments count.'); ?> </td>
			</tr>
			 
			<tr valign="top">
			<th scope="row"><?php echo __('The Rank Titles:'); ?></th>
			<td><div id="ranks">
				<?php
				$c = 0;
				
				foreach($options['levels'] as $key ){
				
					echo '<p> Title <input type="text" name="baur[levels]['.$c.'][title]" value="'.$key['title'].'" /> -- Count Above : <input type="text" name="baur[levels]['.$c.'][count]" value="'.$key['count'].'" /><span class="remove">Remove</span></p>';
					$c = $c +1;
				}?>
				<span id="here"></span>
				<span class="add">Add Titles</span>
				<script>
					jQuery(document).ready(function() {
						var count = <?php echo $c; ?>;
						jQuery(".add").click(function() {
							count = count + 1;
							//jQuery("#ranks > p:first-child").clone(true).insertBefore("#here");
							jQuery('#here').append('<p> Title <input type="text" name="baur[levels]['+count+'][title]" value="" /> -- Count Above : <input type="text" name="baur[levels]['+count+'][count]" value="" /><span class="remove">Remove</span></p>' );
							return false;
						});
						
						jQuery(".remove").click(function() {
							jQuery(this).parent().remove();
						});
					
					});
				</script>
			</div></td>
			</tr>
			
			<tr valign="top">
			<th scope="row"><?php echo __('Each Post counts as how many points'); ?></th>
			<td><input type="text" name="baur[post]" value="<?php echo $options['post']; ?>" /></td>
			</tr>
			<tr valign="top">
			<th scope="row"><?php echo __('Each Comment counts as how many points'); ?></th>
			<td><input type="text" name="baur[comment]" value="<?php echo $options['comment']; ?>" /></td>
			</tr>

			</table>
			

			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>

			</form>
		</div>

		<?php
	}
}
